Subject: Re: Newbie grief

From: Rich Pixley <[email-masked]>
Date: Fri, 04 May 2012 10:57:59 -0700

On 5/3/12 21:35 , Michael Witten wrote:
> On Thu, 3 May 2012 20:13:01 -0700, Nathan Gray wrote:
>
>> On Thu, May 3, 2012 at 6:01 PM, Illia Bobyr<[email-masked]>  wrote:
>>> It is just a "non-fast forward" move of a branch tip.  This term
>>> describes what happens precisely :)
>>>
>>> It is true, that the term is non obvious to the new comers.
>>> One may google and get an explanation of the error pretty quickly.
>>> First hit for "git non fast forward error" gives an explanation from a
>>> new comer point of view for the simplest case.
>> I just led a team of reasonably bright people through a transition
>> from SVN to git.  Not one of them understood this message.  Every one
>> of them thought something was broken.  This is a very common
>> occurrence, so a short, simple message without jargon for this error
>> would be a big, big win.
> Well, what is your suggestion?
>
> Nobody in this thread has yet provided an explicit improvement because
> the actual complaint is that the vast majority of people (including
> supposed "professionals") don't RTFM; it never even occurs to them!
>
> Let's look at the message in question:
>
>    To $uri_for_central_repo
>     ! [rejected]        HEAD ->  feature_0 (non-fast-forward)
>    error: failed to push some refs to '$uri_for_central_repo'
>    To prevent you from losing history, non-fast-forward updates were rejected
>    Merge the remote changes (e.g. 'git pull') before pushing again.  See the
>    'Note about fast-forwards' section of 'git push --help' for details.
>
> Not only does this already spoonfeed the reader with a suggested
> command for getting back on track (i.e., 'git pull'), but it also
> explicitly points out the relevant documentation and HOW to gain
> immediate access to that information from the command line!
Let's take it line by line.

"Rejected - mumble" - the tool did not do what you asked.
"error: failed to mumble"  - your data is corrupt.
"To prevent you mumble mumble" - you're not allowed to do what you want

I stopped reading there.

I'm not saying this is a correct interpretation.  I'm offering it as a 
data point from a sophisticated, although new, user.

I've already offered a suggestion for rewording.

--rich